pipeline {
    agent any
    
    stages {
        stage('Checkout') {
            steps {
                // Clone the Git repository
                git branch: 'main', credentialsId: 'jenkins', url: 'git@gitlab.com:faycel.benyounes/projet10-spring.git'
            }
        }

        stage('Build') {
            steps {
                // Set up Maven
                script {
                    def mavenHome = tool 'maven'
                    def mavenCMD = "${mavenHome}/bin/mvn"

                    // Run Maven clean and install
                    sh "${mavenCMD} clean install"
                }
            }
        }
    

    stage('Docker') {
          steps {
              script{
                  sh "docker build -t spring-image:v1 ."
                  withCredentials([usernamePassword(credentialsId: 'dockerhub', usernameVariable: 'faycel.benyounes@orange.fr', passwordVariable: 'dckr_pat_74XcjwMX2EdlahH523xUApg44lY')]) {
                  sh "docker build -t spring-image:v1 ."
                  sh "docker tag spring-image:v1 faisalben/spring-image:v1"
                  sh "docker login -u 'faycel.benyounes@orange.fr' -p 'dckr_pat_74XcjwMX2EdlahH523xUApg44lY'"
                  sh "docker push 'faisalben/spring-image:v1'"
}
}

}
}
    stage('Deploy app on K8s') {
steps  {
script{
withKubeCredentials(kubectlCredentials: [[caCertificate: '', clusterName: 'demo1', contextName: '', credentialsId: 'kubjenkins', namespace: 'default', serverUrl: 'https://172.31.14.197:6443']]) {
sh "/usr/bin/kubectl apply -f $JENKINS_HOME/workspace/projet10/webapp-deployement.yml"
sh "/usr/bin/kubectl apply -f $JENKINS_HOME/workspace/projet10/webapp-service.yml"
}
}
}
}

}
}

